package com.fp.persistence.pgeneral.gene;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;

import com.fp.dto.hb.Cache;
import com.fp.dto.hb.HibernateBean;
import javax.persistence.Version;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENEBALANCETYPEDETAIL*/
@Entity(name="TgeneBalanceTypeDetail")
@Table(name="TGENEBALANCETYPEDETAIL")
public class TgeneBalanceTypeDetail extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable,Cache{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneBalanceTypeDetail
*/
@EmbeddedId
private TgeneBalanceTypeDetailKey pk;
@Version
@Column(name="RECORDVERSION", nullable=true)

/**
* Manejo de bloqueo optimista del registro
*/
private Integer recordversion;

@Column(name="COMMANDBALANCE", nullable=true)

/**
* Clase que se encarga de la actualización de saldos
*/
private String commandbalance;

@Column(name="FIELDNAME", nullable=true)

/**
* Campo que actualiza la actualiza en el commandbalance asociado al tipo de saldo, Ejemplo cash, Locked
*/
private String fieldname;

@Column(name="ACCOUNTINGCODE", nullable=true)

/**
* Codigo contable asociado al tipo de saldo grupo de balance, Ejemplo 2101PPMMEE01 o   51040101
*/
private String accountingcode;

@Column(name="MANAGECACHE", nullable=true)

/**
* Indica si el registro se almacena en cache del servidor de aplicaciones.
*/
private String managecache;

@Column(name="ISPROVISON", nullable=true)

/**
* Indica que en valor del tipo de saldo es resultado del calculo de provisiones
*/
private String isprovison;

@Column(name="CALCULATEPROVISION", nullable=true)

/**
* Indica si se calcula accruales sobre el saldo asociado al tipo de saldo 
*/
private String calculateprovision;

@Column(name="BRANCHAMONG", nullable=true)

/**
* null
*/
private String branchamong;

/**Contructor por defecto*/
public TgeneBalanceTypeDetail(){
}
/**Contructor de TgeneBalanceTypeDetail
@param pPk Clave Primaria del entity
*/
public TgeneBalanceTypeDetail(TgeneBalanceTypeDetailKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneBalanceTypeDetail
*/
public static TgeneBalanceTypeDetail find(EntityManager pEntityManager,TgeneBalanceTypeDetailKey pKey) throws Exception{
    TgeneBalanceTypeDetail obj = pEntityManager.find(TgeneBalanceTypeDetail.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneBalanceTypeDetail
@return El objeto que referencia a la Clave primaria de TgeneBalanceTypeDetail
*/
public TgeneBalanceTypeDetailKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneBalanceTypeDetail
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneBalanceTypeDetail
*/
public void setPk(TgeneBalanceTypeDetailKey pPk){
  pk=pPk;
}
/**Obtiene el valor de recordversion
@return valor de recordversion*/
public Integer getRecordversion(){
  return recordversion;
}
/**Fija el valor de recordversion
@param pRecordversion nuevo Valor de recordversion*/
public void setRecordversion(Integer pRecordversion){
  recordversion=pRecordversion;
}

/**Obtiene el valor de commandbalance
@return valor de commandbalance*/
public String getCommandbalance(){
  return commandbalance;
}
/**Fija el valor de commandbalance
@param pCommandbalance nuevo Valor de commandbalance*/
public void setCommandbalance(String pCommandbalance){
  commandbalance=pCommandbalance;
}

/**Obtiene el valor de fieldname
@return valor de fieldname*/
public String getFieldname(){
  return fieldname;
}
/**Fija el valor de fieldname
@param pFieldname nuevo Valor de fieldname*/
public void setFieldname(String pFieldname){
  fieldname=pFieldname;
}

/**Obtiene el valor de accountingcode
@return valor de accountingcode*/
public String getAccountingcode(){
  return accountingcode;
}
/**Fija el valor de accountingcode
@param pAccountingcode nuevo Valor de accountingcode*/
public void setAccountingcode(String pAccountingcode){
  accountingcode=pAccountingcode;
}

/**Obtiene el valor de managecache
@return valor de managecache*/
public String getManagecache(){
  return managecache;
}
/**Fija el valor de managecache
@param pManagecache nuevo Valor de managecache*/
public void setManagecache(String pManagecache){
  managecache=pManagecache;
}

/**Obtiene el valor de isprovison
@return valor de isprovison*/
public String getIsprovison(){
  return isprovison;
}
/**Fija el valor de isprovison
@param pIsprovison nuevo Valor de isprovison*/
public void setIsprovison(String pIsprovison){
  isprovison=pIsprovison;
}

/**Obtiene el valor de calculateprovision
@return valor de calculateprovision*/
public String getCalculateprovision(){
  return calculateprovision;
}
/**Fija el valor de calculateprovision
@param pCalculateprovision nuevo Valor de calculateprovision*/
public void setCalculateprovision(String pCalculateprovision){
  calculateprovision=pCalculateprovision;
}

/**Obtiene el valor de branchamong
@return valor de branchamong*/
public String getBranchamong(){
  return branchamong;
}
/**Fija el valor de branchamong
@param pBranchamong nuevo Valor de branchamong*/
public void setBranchamong(String pBranchamong){
  branchamong=pBranchamong;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneBalanceTypeDetail))return false;
    TgeneBalanceTypeDetail that = (TgeneBalanceTypeDetail) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneBalanceTypeDetail
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneBalanceTypeDetail
*/
public Object createInstance(){
 TgeneBalanceTypeDetail instance=new TgeneBalanceTypeDetail();	
 instance.setPk(new TgeneBalanceTypeDetailKey());
 return instance;
}
/**Clona la entidad TgeneBalanceTypeDetail
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneBalanceTypeDetail p=(TgeneBalanceTypeDetail)this.clone();
  p.setPk((TgeneBalanceTypeDetailKey)this.pk.cloneMe());
  return p;
}
}
